#!perl

# $Id: install.pl,v 1.13 2008/03/23 13:54:02 maeda Exp $

# Copyright 2008 by Kaoru Maeda <kaoru.maeda@gmail.com>
#
# This program is free software; you may redistribute it and/or modify it
# under the same terms as Perl itself.

use strict;

# g
#  1. ݒ荀ڂKvɉĕύX
#  2. install.pl_uNbN
#  3. CXg[Ŏs鏈\̂ŁA
#     sėǂ΃^[A~ȂRg[CŎ~߂Ă

# ݒ荀----------------------------------------------------

# 1: I[g}LV}CỶʎw_CAOoǂ
#   0=oȂ 1=o
my $showautomaxdialog = 1;

# 2: I[g}LV}CYݒ艹
my $automaxlevel = -12;

# 3: ŏIGR[fBO̖ڕWrbg[g
#   kbpsPʁB\[Xrbg[g̏ꍇ̓\[Xɍ킹܂
my $targetbp = 128;

# 4: Sound Engineݒt@CtH_
#   ʏƈႤꍇ̓tpXŏĂB
#   \\\ƏĂB
my $seconfigdir = "$ENV{APPDATA}\\Cycle of 5th\\SoundEngine";

# 5: MP3̃fR[hPsyencgǂ
#   0=gȂ 1=g
my $usemp3decode = 0;

# 6: 5g̏ꍇAAudioConvertermp3I[vE
my $killVBMP3open = 0;

# 7: Psyencgꎞt@C̒utH_
#   undef = PsyencCXg[tH_
my $tmpdir = undef;
# my $tmpdir = "$ENV{TEMP}";

# ݒ荀ڂBȍ~͂Ȃł------------------

use Cwd 'abs_path';
use Config;
use Encode;
use Win32;

open LOG, ">>install_log.txt";
select LOG; $| = 1;
select STDOUT; $| = 1;
message(("-" x 60) . "\n");
message("CXg[Jn: " . scalar(localtime()) . "\n");

my @what_to_do;
my @errors;
my %overwrite;
my $sedir = slashize($seconfigdir);

# Sound Enginẽ`FbN
my @scripts = qw(Sec/psyenc.sec Ses/psyenc.ses);
if (-d $sedir) {
    for my $f (@scripts) {
	$overwrite{$f} = (-f "$sedir/$f") ? '㏑' : "";
    }
} else {
    push(@errors, <<EOL);
Sound Engine̐ݒtH_܂
  Sound Engine̓CXg[܂?
  install.pl\$seconfigdir𐳂ݒ肵ĂB
  ݂̐ݒl: $seconfigdir
EOL
    ;
}

# Kvȃt@Č

my $homedir = slashize(abs_path());
my $homedir_d = backslashize($homedir);
my @necessary_files = qw(ffmpeg.exe pthreadGC2.dll swfextract.exe);
for my $f (@necessary_files) {
    unless (-f $f) {
	push(@errors, "$f  $homedir_d ɒuĂ\n");
    }
}

# ꎞtH_̌

defined ($tmpdir) or $tmpdir = $homedir;
$tmpdir = slashize($tmpdir);
unless (-d $tmpdir) {
    push(@errors, "ꎞtH_ $tmpdir ݂܂\n");
}

# PerloCǐ
my $perlse = "$sedir/perl.exe";
my $perlbindir = $Config{bin};
my $perlsrc = "$perlbindir/perl.exe";
if (!perl_ok()) {
    push(@what_to_do, [<<EOL, \&copy_perl]);
perl.exe  $sedir ɃRs[܂
EOL
    ;
}

# PerlW[̌

my @modules = (
	       [ 'MP3::Info', 1.23 ],
	       [ 'MP4::Info', 1.11 ],
	       [ 'MP3::Tag',  0.97 ],
	       );
my @need_modules = missing_modules(@modules);

unless (@need_modules == 0) {
    my $mm = join(", ", map {$_->[0].$_->[1]} @need_modules);
    push (@what_to_do, [<<EOL, \&install_modules]);
ȉPerlW[ ActiveState _E[h
  CXg[܂:
    $mm
EOL
    ;
}

sub install_modules {
    for my $m (@need_modules) {
	my $ppm_modname = $m->[0];
	$ppm_modname =~ s/::/-/g;
	run("ppm install $ppm_modname");
    }
    my @still_missing = missing_modules(@need_modules);
    if (@still_missing) {
	my $mm = join(", ", map {$_->[0] . ($_->[1] ? "(Found $_->[1])" : "")} @still_missing);
	push (@errors, <<EOL);
ȉ̃W[CXg[łȂÂł:
    $mm
  vLVgĂꍇ͈ȉ̊ϐmFĂ:
    HTTP_proxy, HTTP_proxy_user, HTTP_proxy_pass
EOL
	;
    }
}

# ɃG[͂?
error_check();

# Ȃ΂邱ƃXg쐬
push (@what_to_do,
      [<<EOL, sub { temp_copy("psyenc.pl_", "psyenc.pl") }],
psyenc.plɐݒl𔽉f܂
EOL
      [<<EOL, sub { temp_copy("psyenc.ses", "$sedir/Ses/psyenc.ses") }],
ꊇϊXNvgSound Engine$overwrite{"Ses/psyenc.ses"}CXg[܂
    $sedir/Ses/psyenc.ses
EOL
      [<<EOL, sub { temp_copy("psyenc.sec", "$sedir/Sec/psyenc.sec") }],
`ϊR}hCSound Engine$overwrite{"Sec/psyenc.sec"}CXg[܂
    $sedir/Sec/psyenc.sec
EOL
      );

# AudioConvertermp3I[vE
if ($usemp3decode && $killVBMP3open) {
    my $ac_sec = "$sedir/Sec/AudioConverter.sec";
    my $found = 0;
    if (-f $ac_sec) {
	open IN, "<$ac_sec";
	local $/ = '';
	while (<IN>) {
	    if (/^\[Open\]/ && /Extension=mp3\s/ && /VBMP3/) {
		$found = 1;
		last;
	    }
	}
	close IN;
    }
    if ($found) {
	push (@what_to_do, [<<EOL, sub { fix_ac_sec($ac_sec) }]);
VBMP3.DLLɂmp3ϊE܂BR}hC`t@C
    $ac_sec
    ̒ɂݒ̂AVBMP3.DLLg[Open]mp3ɂāA
    Extension=mp3Extension=mp3xɕς܂B
    ̃t@C $homedir_d ɃRs[Ă܂B
EOL
		     ;
    }
}

# sĂ?
message("ȉ̏s܂:\n");
for my $w (@what_to_do) {
    message("  " . $w->[0]);
}

message("낵ł?
  OKȂ烊^[ACXg[~Ȃ
  n܂CTRL-ĆA邢͂̑ [Y/n]: ");
my $ans = <STDIN>;
if ($ans =~ /n/i) {
    message("\n~܂B\n");
    pause();
    exit(1);
}

# CXg[s
message("\nCXg[Jn܂B\n");
for my $w (@what_to_do) {
    message($w->[0]);
    $w->[1]();
    error_check();
}

error_check();

message("܂\n");
pause();
exit(0);

# ȉTu[`

sub run {
    my $cmd = shift;
    message("$cmd\n");
    system($cmd);
}

sub message {
    print STDOUT $_[0];
    print LOG $_[0];
}

sub pause {
    message("^[L[Ă: ");
    my $ans = <STDIN>;
}

sub missing_modules {
    my @missing;
    for my $m (@_) {
	my ($modname, $reqver) = @$m;
	my $found = eval qq[require $modname; \$${modname}\::VERSION];
	if ($@) {
	    push @missing, [$modname, ""];
	} elsif ($found < $reqver) {
	    push @missing, [$modname, " (Found $found; Need $reqver)"];
	}
    }
    @missing;
}

sub error_check {
    if (@errors) {
	for (@errors) {
	    message($_);
	}
	message("I܂B\n");
	pause();
	exit(1);
    }
}

sub perl_ok {
    -s $perlsrc == -s $perlse;
}

sub copy_perl {
    use File::Copy;
    copy($perlsrc, $perlse);
    if (!perl_ok()) {
	push(@errors, <<EOL);
perl.exe ̃Rs[Ɏs܂
  perl.exe $sedir Ɏ蓮ŃRs[AĎsĂ
EOL
	;
    }
}

sub temp_copy {
    my ($src, $dst) = @_;
    my $mp3ext = $usemp3decode ? 'mp3' : 'mp3p';
    eval {
	open IN, "<$src" or die "$src ǂݍ߂܂\n";
	open OUT, ">$dst" or die "$dst 쐬ł܂\n";
	while (<IN>) {
	    if (/\%TARGETBPDEF\%/) {
		$_ = qq[my \$targetbp = $targetbp;\n];
	    } elsif (/\%HOMEDIRDEF\%/) {
		$_ = qq[my \$home = '$homedir';\n];
	    } elsif (/\%TMPDIRDEF\%/) {
		$_ = qq[my \$tmp = '$tmpdir';\n];
	    } elsif (/\%AUTOMAXSHOW\%/) {
		if ($showautomaxdialog) {
		    $_ = qq[Option=ShowOnce\n];
		} else {
		    $_ = '';
		}
	    }
	    s/\%HOMEDIR\%/$homedir_d/;
	    s/\%AUTOMAXLEVEL\%/$automaxlevel/;
	    s/\%MP3EXTBYPSYENC\%/$mp3ext/;
	} continue {
	    print OUT or  die "$dst ɏ߂܂\n";
	}
	    ;
	close IN;
	close OUT or die  "$dst ɏ߂܂\n";
    };
    if ($@) {
	push (@errors, $@);
	unlink $dst;
    }
}

sub fix_ac_sec {
    my $src = shift;
    my $src_base = $src;
    $src_base =~ s[.*/][];
    my $backupfile = "$homedir/$src_base";
    use File::Copy;
    unless (copy($src, $backupfile)) {
	push(@errors, "$backupfile 쐬ł܂B~܂\n");
	return;
    }
    my @buff;

    eval {
	open IN, "<$backupfile" or die "$backupfile ǂݍ߂܂\n";
	open OUT, ">$src" or die "$src 쐬ł܂\n";
	local $/ = '';
	while (<IN>) {
	    if (/^\[Open\]/ && /Extension=mp3\s/ && /VBMP3/) {
		s/Extension=mp3/Extension=mp3x/;
	    }
	} continue {
	    print OUT or die  "$src ɏ߂܂\n";
	}
	    ;
	close IN;
	close OUT or die  "$src ɏ߂܂\n";
    };
    if ($@) {
	push (@errors, $@);
	unless (copy($backupfile, $src)) {
	    push(@errors, <<EOL);
$src  $backupfile 畜ł܂B
  ŕĂB
EOL
	    ;
	}
    }
}

sub backslashize {
    pathdelim_convert($_[0], 'back');
}

sub slashize {
    pathdelim_convert($_[0], 'slash');
}

sub pathdelim_convert {
    my ($src, $dir) = @_;
    my $usrc = decode('sjis', $src);
    if ($dir eq 'back') {
	$usrc =~ s[/][\\]g;
    } elsif ($dir eq 'slash') {
	$usrc =~ s[\\][/]g;
    }
    encode('sjis', $usrc);
}
